from dataclasses import dataclass
from typing import Optional


from routeviews import peeringdb, typez


@dataclass
class PeerRequest:
    """A possible BGP Peering between two routers. 

    - Generated by 'routeviews.peeringdb.Network.potential_peerings_with_network(other_network)'
    - Ingested by 'routeviews.ansible.CollectorConfig'.
    """
    my_network: 'peeringdb.Network'
    my_address: typez.IPAddr
    your_network: 'peeringdb.Network'
    your_address: typez.IPAddr
    exchange: Optional[str] = None  # Multihop peer requests have no exchange!
